﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using Microsoft.SCP;
using Microsoft.SCP.Rpc.Generated;

namespace LicensePlateReaderApplication
{
    public class FilterBolt : ISCPBolt
    {
        private Context ctx;

        public FilterBolt(Context ctx)
        {
            this.ctx = ctx;

            // Define input stream schema
            Dictionary<string, List<Type>> inputSchema = new Dictionary<string, List<Type>>();
            inputSchema.Add("default", new List<Type>() { typeof(LPREvent) });
            this.ctx.DeclareComponentSchema(new ComponentStreamSchema(inputSchema, null));

            // Define output stream schem
            Dictionary<string, List<Type>> outputSchema = new Dictionary<string, List<Type>>();
            outputSchema.Add("default", new List<Type>() { typeof(LPREvent) });
            this.ctx.DeclareComponentSchema(new ComponentStreamSchema(inputSchema, outputSchema));
        }

        public static FilterBolt Get(Context ctx, Dictionary<string, Object> parms)
        {
            return new FilterBolt(ctx);
        }

        public void Execute(SCPTuple tuple)
        {
            LPREvent lprEvent = (LPREvent)tuple.GetValue(0);

            // Emit only tuple violating speed limit to output stream
            if (lprEvent.Speed > 60)
            {
                this.ctx.Emit(new Values(lprEvent));
            }
        }
    }
}