﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Threading;
using Microsoft.SCP;
using Microsoft.SCP.Rpc.Generated;

namespace LicensePlateReaderApplication
{
    public class LPRSpout : ISCPSpout
    {
        private Context ctx;
        private Random r = new Random();

        public LPRSpout(Context ctx)
        {
            this.ctx = ctx;

            // Define output stream schema
            Dictionary<string, List<Type>> outputSchema = new Dictionary<string, List<Type>>();
            outputSchema.Add("default", new List<Type>() { typeof(LPREvent) });
            this.ctx.DeclareComponentSchema(new ComponentStreamSchema(null, outputSchema));
        }

        public static LPRSpout Get(Context ctx, Dictionary<string, Object> parms)
        {
            return new LPRSpout(ctx);
        }

        public void NextTuple(Dictionary<string, Object> parms)
        {
            // Emit a new LPR event to output stream
            ctx.Emit(new Values(LPREvent.CreateEvent()));
        }

        public void Ack(long seqId, Dictionary<string, Object> parms)
        {
            throw new NotImplementedException();
        }

        public void Fail(long seqId, Dictionary<string, Object> parms)
        {
            throw new NotImplementedException();
        }
    }
}