ADD JAR wasb:///OozieWorkflow/csv-serde-1.1.2.jar;

DROP TABLE IF EXISTS OnTimePerformance;
DROP TABLE IF EXISTS AirlineLookup;

CREATE EXTERNAL TABLE OnTimePerformance (Year STRING,Quarter STRING,Month STRING,DayofMonth STRING,DayOfWeek STRING,FlightDate STRING,UniqueCarrier STRING,AirlineID STRING,Carrier STRING,TailNum STRING,FlightNum STRING,OriginAirportID STRING,OriginAirportSeqID STRING,OriginCityMarketID STRING,Origin STRING,OriginCityName STRING,OriginState STRING,OriginStateFips STRING,OriginStateName STRING,OriginWac STRING,DestAirportID STRING,DestAirportSeqID STRING,DestCityMarketID STRING,Dest STRING,DestCityName STRING,DestState STRING,DestStateFips STRING,DestStateName STRING,DestWac STRING,CRSDepTime STRING,DepTime STRING,DepDelay STRING,DepDelayMinutes STRING,DepDel15 STRING,DepartureDelayGroups STRING,DepTimeBlk STRING,TaxiOut STRING,WheelsOff STRING,WheelsOn STRING,TaxiIn STRING,CRSArrTime STRING,ArrTime STRING,ArrDelay STRING,ArrDelayMinutes STRING,ArrDel15 STRING,ArrivalDelayGroups STRING,ArrTimeBlk STRING,Cancelled STRING,CancellationCode STRING,Diverted STRING,CRSElapsedTime STRING,ActualElapsedTime STRING,AirTime STRING,Flights STRING,Distance STRING,DistanceGroup STRING,CarrierDelay STRING,WeatherDelay STRING,NASDelay STRING,SecurityDelay STRING,LateAircraftDelay STRING,FirstDepTime STRING,TotalAddGTime STRING,LongestAddGTime STRING,DivAirportLandings STRING,DivReachedDest STRING,DivActualElapsedTime STRING,DivArrDelay STRING,DivDistance STRING,Div1Airport STRING,Div1AirportID STRING,Div1AirportSeqID STRING,Div1WheelsOn STRING,Div1TotalGTime STRING,Div1LongestGTime STRING,Div1WheelsOff STRING,Div1TailNum STRING,Div2Airport STRING,Div2AirportID STRING,Div2AirportSeqID STRING,Div2WheelsOn STRING,Div2TotalGTime STRING,Div2LongestGTime STRING,Div2WheelsOff STRING,Div2TailNum STRING,Div3Airport STRING,Div3AirportID STRING,Div3AirportSeqID STRING,Div3WheelsOn STRING,Div3TotalGTime STRING,Div3LongestGTime STRING,Div3WheelsOff STRING,Div3TailNum STRING,Div4Airport STRING,Div4AirportID STRING,Div4AirportSeqID STRING,Div4WheelsOn STRING,Div4TotalGTime STRING,Div4LongestGTime STRING,Div4WheelsOff STRING,Div4TailNum STRING,Div5Airport STRING,Div5AirportID STRING,Div5AirportSeqID STRING,Div5WheelsOn STRING,Div5TotalGTime STRING,Div5LongestGTime STRING,Div5WheelsOff STRING,Div5TailNum STRING) ROW FORMAT SERDE 'com.bizo.hive.serde.csv.CSVSerde' STORED AS TEXTFILE LOCATION '${OnTimePerformance_Data}' tblproperties ("skip.header.line.count"="1");

CREATE EXTERNAL TABLE AirlineLookup (AirlineID STRING, Airline STRING) ROW FORMAT SERDE 'com.bizo.hive.serde.csv.CSVSerde' STORED AS TEXTFILE LOCATION '${Airline_Lookup}' tblproperties ("skip.header.line.count"="1");
